#include "InputWindow.hpp"
#include "SubscriptionWindow.hpp"
#include "SoftkeyWindow.hpp"
#include "rssreader.hpp"

InputWindow::InputWindow() : SFRTitleWindow(SFRApplication::GetInstance(),
    SFXGraphics::GetDeviceRectangle().Deflate(20, 20).SubBottom(15),
    "ҏW") static_throws
{
    SFXRectangle rectangle = GetContentWorld();
    SInt16 height = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + 4;
    SInt16 space = height / 3;
    rectangle.SetHeight(height);
    rectangle.Offset(10, 10);

    // x̍쐬
    ::new SFRLabelControl(this, rectangle, "^Cg");
    rectangle.Offset(20, height + space);
    rectangle.SubWidth(35);

    // ^Cg͗p
    _titleTextControl = ::new SFREditboxControl(
        this, rectangle, SFXWideString::EmptyInstance());
    rectangle.Offset(-20, height + space);
    new SFRLabelControl(this, rectangle, "URL");
    rectangle.Offset(20, height + space);

    // URL͗p
    _urlTextControl = new SFREditboxControl(
        this, rectangle, SFXWideString::EmptyInstance());
    rectangle.Offset(-20, height + space + 10);
    rectangle.SetWidth(50);
    rectangle.AddHeight(2);
    _urlTextControl->SetText("http://");

    // {^̍쐬
    SFRButtonControlPtr okButton = new SFRButtonControl(
        this, rectangle, "o^");
    rectangle.AddX(60);
    rectangle.SetWidth(120);
    SFRButtonControlPtr cancelButton = new SFRButtonControl(
        this, rectangle, "LZ");
    // tH[JX擪
    FocusNext();

    // L[nh̓o^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    // OK {^Ƃ̃nho^
    if (okButton != null && static_try()) {
        static_throw(
            okButton->RegisterHandler(
                SREVT_CONTROL, HANDLER_BEFORE,
                HANDLER_FUNCTION(OkButtonHandler)));
    }
    // LZ{^Ƃ̃nho^
    if (cancelButton != null && static_try()) {
        static_throw(
            cancelButton->RegisterHandler(
                SREVT_CONTROL, HANDLER_BEFORE,
                HANDLER_FUNCTION(CancelButtonHandler)));
    }
    // ZNgL[Ƃ̃nho^ (eLXgRg[p)
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SFEVT_KEY, AVK_SELECT, HANDLER_AFTER,
                HANDLER_FUNCTION(SelectHandler)));
    }
    return;
}

//\tgL[̕XV
Void InputWindow::SetSoftkey()
{
    // 󕶎
    SoftkeyWindow::GetInstance()->Set("");
    return;
}

// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(InputWindow, OnKey, event)
{
    switch (event.GetP16()) {
        case AVK_CLR:

        case AVK_SOFT2:
        case AVK_SOFT1:


            if (_titleTextControl->GetStatusTarget() || _urlTextControl->GetStatusTarget()){

                _titleTextControl->SetStatusTarget(false);
                _urlTextControl->SetStatusTarget(false);

                FocusNext();
            }
            else

            // EBhE
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
                SRP16_TERMINATE_INVOKE, true));
            SubscriptionWindow::SetSoftkey();
            return true;
    // tH[JXړ
        case AVK_UP:
            FocusUp();
            return true;
        case AVK_LEFT:
            FocusLeft();
            return true;
        case AVK_DOWN:
            FocusDown();
            return true;
        case AVK_RIGHT:
            FocusRight();
            return true;
        default:
            break;
    }
    return false;
}

// OK {^̃nh
HANDLER_IMPLEMENT_VOIDCONTROL(InputWindow, OkButtonHandler, result, control)
{
    unused(control);
    unused(result);

    // eLXgRg[^Cg URL 擾
    RSSFeedPtr feed = ::new RSSFeed(_titleTextControl->GetText(),
        _urlTextControl->GetText());
    if (feed != null) {
         // G[
        if (!rssreader::GetRSSFeedList()->Add(feed)) {
            ::delete feed;
        }
        else {
            // ǉf[^ۑ
            rssreader::GetRSSFeedList()->SaveToFile();
        }
    }
    // _CAO\
    SFRMessageDialogPtr dialog = ::new SFRMessageDialog(
        SFXGraphics::GetDeviceRectangle().Deflate(10, 100),
        "o^܂B", "OK");
    if (static_try()) {
        static_throw(dialog->RegisterHandler(
            SREVT_DIALOG, HANDLER_BEFORE, HANDLER_FUNCTION(EndHandler)));
    }
    SubscriptionWindow::SetSoftkey();
    return;
}

// LZ{^̃nh
HANDLER_IMPLEMENT_VOIDCONTROL(InputWindow, CancelButtonHandler, result, control)
{
    unused(control);
    unused(result);

    SubscriptionWindow::SetSoftkey();
    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    return;
}

// _CAO OK {^Ƃ̃nh
HANDLER_IMPLEMENT_VOIDDIALOG(InputWindow, EndHandler, result, dialog)
{
    unused(dialog);
    unused(result);

    SubscriptionWindow::SetSoftkey();
    // InputWindow 
    SFRWindowPtr window = static_cast<SFRWindowPtr>(GetPrevious());
    window->Invoke(
    SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    // _CAO
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    return;
}
