#include "rssreader.hpp"
#include "SubscriptionWindow.hpp"
#include "MainWindow.hpp"
#include "InputWindow.hpp"
#include "SoftkeyWindow.hpp"

SubscriptionWindow::SubscriptionWindow(SFXRectangleConstRef rectangle) :
    SFRTitleWindow(SFRApplication::GetInstance(),
    rectangle, "tB[hꗗ") static_throws
{
    // nh̓o^
    if (static_try()) {
        static_throw(
            RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT,
                HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
    }

    if (static_try()) {
        static_throw(
            RegisterHandler(SFEVT_KEY,
                HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    SetSoftkey();
    // J[\ʒuݒ
    _displine = static_cast<SInt16>(rssreader::GetRSSFeedList()
        ->FirstIndexOf(rssreader::GetCurrentFeed()));
    if (_displine > 0) {
        --_displine;
        _cursor = 1;
    } else {
        _displine = 0;
        _cursor = 0;
    }
    // \svZ
    _maxline = GetContentWorld().GetHeight()
        / SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) / 2;

    _move = 0;
    return;
}

// \tgL[EBhEɕݒ肷
Void SubscriptionWindow::SetSoftkey(Void)
{
    SoftkeyWindow::GetInstance()->Set("XV", "I", "ǉ");
    return;
}

HANDLER_IMPLEMENT_VOIDRENDER(SubscriptionWindow, OnRenderContent, graphics)
{
    //ʃTCY擾
    SFXRectangle rectangle(GetContentWorld());
    SFXRGBColor forecolor;
    SFXRGBColor backcolor;
    SFXAnsiString buff;
    SIntN i;

    // tHg̍擾
    SInt16 height = graphics->GetFontHeight();
    // ̒`̒ӂoĂ
    SInt16 bottom = rectangle.GetBottom();
    // rectangle ̍tHg̍ɐݒ
    rectangle.SetHeight(height);

    SFRTitleWindow::ContentHandler(graphics);
    for (i = _displine;  i < _displine + _maxline ; ++i) {
        // J[\̂sȂ
        if (i - _displine == _cursor) {
            forecolor.Set(0xff, 0xff, 0xff, 0x00);
            backcolor.Set(0x66, 0x66, 0xff, 0x00);
        }
        else {
            forecolor.Set(0x00, 0x00, 0x00, 0x00);
            // sڂƊsڂŐFς
            if (i % 2 == 0) {
                backcolor.Set(0xdd, 0xdd, 0xff, 0);
            } else {
                backcolor.Set(0xee, 0xee, 0xff, 0);
            }
        }
        graphics->FillRectangle(rectangle, backcolor);
        graphics->SetForeColor(forecolor);
        if (i < rssreader::GetRSSFeedList()->GetSize()) {
            if ((*rssreader::GetRSSFeedList())[i]->_title.IsEmptyCString()) {
                //feediԖڂ̕`
                graphics->DrawSingleText("[]",
                    rectangle,
                    IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
            } else {

    if (i - _displine == _cursor) {
                _currentRect = rectangle;
                _currentRect.SubX(_move);
                //feediԖڂ̕`
                graphics->DrawSingleText((*rssreader::GetRSSFeedList())[i]->_title,
                    rectangle,
                    IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);}

                else{
                graphics->DrawSingleText((*rssreader::GetRSSFeedList())[i]->_title,
                    rectangle,
                    IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);}
            }
        }
        // rectangleheightɈړ
        rectangle.AddY(height);
    }
    rectangle.AddY(15);
    // rectangle̍tHg̍̐{
    // i؂邱ƂȂʂɕ\łẼTCYjɂ
    rectangle.SetHeight(((bottom - rectangle.GetTop()) / height) * height);
    graphics->FillRectangle(rectangle, SFXRGBColor(255, 255, 255, 0));
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0)); //F
    if (rssreader::GetRSSFeedList()->GetSize() > _displine + _cursor) {
        //_cursor ̎w feed  url `
        buff= "URL :" + (*rssreader::GetRSSFeedList())[_displine + _cursor]->_url + "\r\n";
        graphics->DrawMultipleTextLeft(
            buff,
            rectangle,
            rectangle.GetOrigin(),
            rectangle.GetWidth());
    }
    //rectanglȅӂ擾
    SFXLine line(rectangle.GetEdgeTop());
    graphics->DrawLine(line, SFXRGBColor(128, 128, 128, 255));
    //10ړ
    line.Unoffset(0, 10);
    graphics->DrawLine(line, SFXRGBColor(128, 128, 128, 255));
    return;
}

// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(SubscriptionWindow, OnKey, event) static_throws
{
    SFXRectangle rectangle;
    SFRMultiDialogPtr dialog;
    SFRMultiDialog::ParamRec dialogParam;
    RSSFeedListRef feedList = *rssreader::GetRSSFeedList();

    switch (event.GetP16()) {
        //L[
        case AVK_DOWN:
            //J[\ԉɂȂ
            if (_cursor == _maxline - 1) {
                ++_displine;
                InvalidateContent();
            } else {
                ++_cursor;
                InvalidateContent();
            }
            UpdateMainWindow();
            return true;

        //L[
        case AVK_UP:
            //J[\ԏɂȂ
            if (_cursor == 0) {
                if (_displine > 0) {
                    --_displine;
                    InvalidateContent();
                }
            } else {
                --_cursor;
                InvalidateContent();
            }
            UpdateMainWindow();
            return true;

        // EL[
        case AVK_RIGHT:
            _move++;
            InvalidateContent();
            return true;

        // L[
        case AVK_LEFT:
            if(_move > 0)
            {
                _move--;
                InvalidateContent();
            }
            return true;

        // Soft1 L[A7 L[
        case AVK_SOFT1: case AVK_7:
            rssreader::SetCurrentFeed(feedList[_displine + _cursor]);
            // ڑmF_CAO\
            dialogParam.text = "ڑJn܂B낵łH";
            dialogParam.ok = "͂";
            dialogParam.cancel = "";
            dialogParam.another = "";
            dialogParam.focus = SFRMultiDialog::FOCUS_OK,
            dialogParam.image = SFBImageSmp(null);
            // _CAÕTCYݒ
            rectangle.Set(SFXGraphics::GetDeviceRectangle());
            rectangle.Deflate(10, 50).SetHeight(150);
            dialog = ::new SFRMultiDialog(rectangle, "ڑ", dialogParam);
            if (dialog != null && static_try()) {
            //nho^
                static_throw(
                    dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
                        HANDLER_FUNCTION(StartConnection)));
            }
            return true;

        // IL[ANAL[
        case AVK_SELECT: case AVK_CLR:
            // EBhE
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
                SRP16_TERMINATE_INVOKE, true));
            MainWindow::SetSoftkey();
            return true;

        // Soft2 L[A9 L[
        case AVK_SOFT2: case AVK_9:
            // tB[hǉEBhEJ
            ::new InputWindow();
            InputWindow::SetSoftkey();
            return true;
    }
    return false;
}

// J[\𓮂Ƃ MainWindow ĕ`悷
Void SubscriptionWindow::UpdateMainWindow(Void)
{
    SFXAnsiString windowTitle;
    MainWindowPtr mainWindow;
    RSSFeedListRef feedList = *rssreader::GetRSSFeedList();

    if (feedList.GetSize() > _displine + _cursor) {
        rssreader::SetCurrentFeed(feedList[_displine + _cursor]);
        windowTitle = rssreader::GetCurrentFeed()->_title;
    } else {
        rssreader::SetCurrentFeed(null);
        windowTitle = SFXAnsiString::EmptyInstance();
    }
    // MainWindow ̎擾
    mainWindow = static_cast<MainWindowPtr>(GetNext());
    // MainWindow ̃^Cgݒ
    mainWindow->SetTitle(windowTitle);
    // MainWindow ĕ`
    mainWindow->InvalidateBase();
    mainWindow->InvalidateContent();
    return;
}

// ڑmF_CAOŁu͂vI񂾂Ƃ
HANDLER_IMPLEMENT_VOIDDIALOG(SubscriptionWindow, StartConnection, result, dialog) static_throws
{
    SFCError error;
    SFXRectangle rectangle;
    SFRDialogPtr connectingDialog;

    switch(result) {
        case SRP16_OK:
            error = _http.Open();
            if (error == SFERR_NO_ERROR) {
                error = _http.SetMethod("GET");
                if (error == SFERR_NO_ERROR) {
                    error = _http.Connect(
                        (*rssreader::GetRSSFeedList())[_displine+ _cursor]->_url,
                        XALLBACK_INTERNAL(ConnectCallback));
                    if (error == SFERR_NO_ERROR) {
                        rectangle.Set(SFXGraphics::GetDeviceRectangle());
                        rectangle.Deflate(10, 100);
                        connectingDialog = ::new SFRMessageDialog(rectangle,
                            "ڑ...", "");
                        if (connectingDialog != null && static_try()) {
                            // L[͂󂯕tȂ悤ɂ
                            static_throw(
                                connectingDialog->RegisterHandler(SFEVT_KEY,
                                    HANDLER_AFTER,
                                    HANDLER_NULL));
                        }
                        // \tgL[ɋ󕶎ݒ
                        SoftkeyWindow::GetInstance()->Set("");
                    }
                }
            }
            if (error != SFERR_NO_ERROR) {
                DisplayErrorDialog();
            }
            break;
        case SRP16_CANCEL:
            SetSoftkey();
            break;
    }
    dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
        SRP16_TERMINATE_INVOKE, true));
    return;
}

Void SubscriptionWindow::DisplayErrorDialog(Void)
{
    SFXRectangle rectangle;
    // Oʂ̃_CAO
    _http.Close();

    SFRResponderPtr dialog = SFRApplication::GetInstance()
        ->GetFront(TYPE_WILDCARD, ATTRIBUTE_WILDCARD);
    if (dialog == null) {
        dialog = SFRApplication::GetInstance()
            ->GetFront(TYPE_WILDCARD, ATTRIBUTE_WILDCARD);
    }

    if (dialog != null) {
        dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
            SRP16_TERMINATE_INVOKE, true));
    }
    rectangle.Set(SFXGraphics::GetDeviceRectangle());
    rectangle.Deflate(10, 100);
    ::new SFRMessageDialog(rectangle, "ڑɎs܂B", "OK");
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
        SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
    return;
}

// ڑmʒmR[obN
XALLBACK_IMPLEMENT_SFXHTTPCONNECTION(SubscriptionWindow, ConnectCallback, error)
{

if (error == SFERR_NO_ERROR) {
        // ǂݎXg[擾
        error = _http.GetStreamReader(1024, &_reader);
        if (error == SFERR_NO_ERROR) {
            // f[^M
            error = _reader.Fetch(XALLBACK_INTERNAL(FetchCallback));
        }
    }
    if (error != SFERR_NO_ERROR) {
        DisplayErrorDialog();
    }
    return;
}

// f[^MʒmR[obN
XALLBACK_IMPLEMENT_SFXBINARYSTREAMREADER(SubscriptionWindow, FetchCallback, error)
{
    SFRResponderPtr dialog;
    SFXAnsiString string;
    RSSFeedPtr feed = (*rssreader::GetRSSFeedList())[_displine + _cursor];

    if (error == SFERR_NO_ERROR) {

        _reader.ReadSFXAnsiString(&string);
        _xml += string;

        // MI
        if (_reader.Ends() && _reader.GetReadableSize() == 0) {
            // SFXHTTPConnection ̏I
            _http.Close();

            //ݎ擾
            feed->_date = SFXDate::CurrentDate();
            // 
            error = feed->Parse(_xml);
            _xml.Clear();

            if (error == SFERR_NO_ERROR) {
                // ̌ʂt@Cۑ
                feed->SaveToFile();
                // Xgɕۑ
                rssreader::GetRSSFeedList()->SaveToFile();
            }
            // Oʂ̃_CAO
            dialog = SFRApplication::GetInstance()->GetFront(TYPE_WILDCARD);
            if (dialog != null) {
                // _CAO
                dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
                    SRP16_TERMINATE_INVOKE, true));
            }
            SetSoftkey();
            // ĕ`
            SFRApplication::GetInstance()->Invoke(
                SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, true));
        }
        else { // ܂Młf[^cĂ
            _reader.Fetch(XALLBACK_INTERNAL(FetchCallback));
        }
    }
    else {
        DisplayErrorDialog();
    }
    return;
}
